(ns rlm.cool-shapes
  "I just couldn't resist playing around with the Shape
   library in Clojure.  This namespace samples images
   and creates a Grid object containg many small circles
   of different colors, one for each sampled pixel

   I'm submitting this late just to show offwhat I was
   working on --- I don't expect it to be graded.

   LATE-Heart-Blending.jpg is the source,
   Late-heart-output is the sampled output."
  {:author "Robert McIntyre"}
  (:import [shapes
	    Circle
	    Colored
	    Grid
	    Horizontal
	    Layered
	    Polygon
	    Scaled
	    Vertical
	    Rotated]
	   
	   [core
	    JPS
	    CurrentPoint
	    RotationAngle]
	   
	   [visitors PostscriptVisitor]
	   [java.awt Color]
	   [ij ImagePlus IJ]
	   [ij.process ImageProcessor ColorProcessor]))

(defn output
  "send a shape to ~/Desktop/output.ps for
   debugging purposes"
  [shape]
  (clojure.contrib.duck-streams/spit
   (clojure.contrib.duck-streams/file-str
     "~/Desktop/output.ps")
   (JPS/postscript shape 400 400)))

(defn bubbles
  "take an image and \"bubbleize\" it --- replace
   the pixels with small sampled circles"
  [#^ImagePlus image accuracy radius]
  (reduce
   (fn [grid [color x y]]
     (.addShape grid
		(Colored. color (Circle. radius))
		x y))
   (Grid.)
   (for [y (range 0 (.getHeight image) accuracy)
	 x (range 0 (.getWidth  image) accuracy)]
     
     [(Color. (.getRGB (.getImage image) x y))
      x y])))

(defn show-bubbles [#^ImagePlus image radius acc]
  (output (Rotated.
	   (Scaled. (bubbles image acc radius)
		    0.7
		    0.7)
	   RotationAngle/Rotate180)))
	   

