(ns rlm.dreams
  "These are functions and ideas that I have generated in dreams or
   on the edge of sleep, hastily written down on scraps of paper in a
   semi-somniac haze..."
  {:author "Robert McIntyre"}
)


(defn not-implemented []
  (throw (Exception. "not-implemented")))

(defn get-current-ns [] *ns*)


(defmacro silence
  "no print statements can escape from this form!!"
  [& body]
  `(binding [*out* (java.io.StringWriter.)
	     *err* (java.io.StringWriter.) 
	     ] ~@body))

(defmacro megadef
  "Like def but defines the var in every namespace
   currently in existance.  Sometimes usefull for weeding
   out namespace errors."
  {:author "Robert McIntyre"}
  [symbol form]
  `(do ~@(map (fn [n] `(intern ~n ~(list 'quote symbol) ~form)) (all-ns))))


(defmacro megaundef
  "hurrrrrrrrrrrr!!!!!!!"
  {:author "Robert McIntyre the Great"}
  [sym]
  `(do ~@(map (fn [n] `(ns-unmap ~n ~(list 'quote sym))) (all-ns))))

(defmacro defn-decorated
  "like defn-memo except it accepts an additional vector of
   decorator functions which will be applied to the base definition."
  {:author "Robert McIntyre"}
  [decorators fn-name & defn-stuff]
  (let [decorations
	(map (fn [d] (list 'alter-var-root (list 'var fn-name) d)) decorators)]
    `(do
       (defn ~fn-name ~@defn-stuff)
       ~@decorations
       (var ~fn-name))))


    
